/*!
 * @module browser-dtector
 * @description A Javascript library to detect browser, version and platform
 * @version 2.0.0
 * @link https://github.com/sibiraj-s/browser-dtector.git
 * @licence MIT License, https://opensource.org/licenses/MIT
 */
var KnownBrowsers={chrome:"Google Chrome",crios:"Google Chrome",edge:"Microsoft Edge",fennec:"Mozilla Firefox",jsdom:"JsDOM",mozilla:"Mozilla Firefox",msie:"Microsoft Internet Explorer",opera:"Opera",opios:"Opera",opr:"Opera",rv:"Microsoft Internet Explorer",safari:"Safari",samsungbrowser:"Samsung Browser"},KnownPlatforms={android:"Android",androidTablet:"Android Tablet",cros:"Chrome OS",fennec:"Android Tablet",ipad:"IPad",iphone:"IPhone",jsdom:"JsDOM",linux:"Linux",mac:"Macintosh",tablet:"Android Tablet",win:"Windows","windows phone":"Windows Phone",xbox:"Microsoft Xbox"},version="2.0.0",toFixed=function(e,r){var o=new RegExp("^-?\\d+(?:.\\d{0,".concat(r||-1,"})?"));return e.toString().match(o)[0]},utils={toFixed:toFixed};function BrowserDtector(e){var r=this;this.userAgent=e||window.navigator.userAgent,this.__VERSION__=version,this.parseUserAgent=function(e){var o={},i=e||r.userAgent,t=i.toLowerCase().replace(/\s\s+/g," "),n=/(edge)\/([\w.]+)/.exec(t)||/(opr)[/]([\w.]+)/.exec(t)||/(jsdom)[/]([\w.]+)/.exec(t)||/(samsungbrowser)[/]([\w.]+)/.exec(t)||/(chrome)[/]([\w.]+)/.exec(t)||/(crios)[/]([\w.]+)/.exec(t)||/(opios)[/]([\w.]+)/.exec(t)||/(version)(applewebkit)[/]([\w.]+).*(safari)[/]([\w.]+)/.exec(t)||/(webkit)[/]([\w.]+).*(version)[/]([\w.]+).*(safari)[/]([\w.]+)/.exec(t)||/(applewebkit)[/]([\w.]+).*(safari)[/]([\w.]+)/.exec(t)||/(webkit)[/]([\w.]+)/.exec(t)||/(opera)(?:.*version|)[/]([\w.]+)/.exec(t)||/(msie) ([\w.]+)/.exec(t)||/(fennec)[/]([\w.]+)/.exec(t)||t.indexOf("trident")>=0&&/(rv)(?::| )([\w.]+)/.exec(t)||t.indexOf("compatible")<0&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(t)||[],s=/(ipad)/.exec(t)||/(ipod)/.exec(t)||/(iphone)/.exec(t)||/(jsdom)/.exec(t)||/(windows phone)/.exec(t)||/(xbox)/.exec(t)||/(win)/.exec(t)||/(tablet)/.exec(t)||/(android)/.test(t)&&!1===/(mobile)/.test(t)&&["androidTablet"]||/(android)/.exec(t)||/(mac)/.exec(t)||/(linux)/.exec(t)||/(cros)/.exec(t)||[],a={name:n[5]||n[3]||n[1]||null,platform:s[0]||null,userAgent:i,version:n[4]||n[2]||null};return a.name&&(o[a.name]=!0,a.name=KnownBrowsers[a.name]||"Unknown"),a.platform&&(o[a.platform]=!0,a.platform=KnownPlatforms[a.platform]),a.version&&(a.shortVersion=utils.toFixed(parseFloat(a.version),2)),a.isAndroid=!!(o.tablet||o.android||o.androidTablet),a.isTablet=!!(o.ipad||o.tablet||o.androidTablet),a.isMobile=!!(o.android||o.androidTablet||o.tablet||o.ipad||o.ipod||o.iphone||o["windows phone"]),a.isDesktop=!!(o.cros||o.mac||o.linux||o.win),a.isWebkit=!!(o.chrome||o.crios||o.opr||o.safari),a.isIE=!(!o.msie&&!o.rv),a},this.getBrowserInfo=function(){var e=r.parseUserAgent();return delete e.isAndroid,delete e.isMobile,delete e.isTablet,delete e.isWebkit,delete e.isDesktop,delete e.isIE,e},this.getBrowserName=function(){return r.parseUserAgent().name},this.getBrowserVersion=function(){return r.parseUserAgent().version},this.getBrowserShortVersion=function(){return r.parseUserAgent().shortVersion},this.getPlatformName=function(){return r.parseUserAgent().platform},this.isAndroid=function(){return r.parseUserAgent().isAndroid},this.isTablet=function(){return r.parseUserAgent().isTablet},this.isMobile=function(){return r.parseUserAgent().isMobile},this.isWebkit=function(){return r.parseUserAgent().isWebkit},this.isDesktop=function(){return r.parseUserAgent().isDesktop},this.isIE=function(){return r.parseUserAgent().isIE},Object.freeze(this)}export default BrowserDtector;