/*!
 * @module browser-dtector
 * @description A Javascript library to detect browser, version and platform
 * @version 2.0.0
 * @link https://github.com/sibiraj-s/browser-dtector.git
 * @licence MIT License, https://opensource.org/licenses/MIT
 */
!function(e,r){"object"==typeof exports&&"undefined"!=typeof module?module.exports=r():"function"==typeof define&&define.amd?define(r):(e=e||self).BrowserDtector=r()}(this,(function(){"use strict";var e={chrome:"Google Chrome",crios:"Google Chrome",edge:"Microsoft Edge",fennec:"Mozilla Firefox",jsdom:"JsDOM",mozilla:"Mozilla Firefox",msie:"Microsoft Internet Explorer",opera:"Opera",opios:"Opera",opr:"Opera",rv:"Microsoft Internet Explorer",safari:"Safari",samsungbrowser:"Samsung Browser"},r={android:"Android",androidTablet:"Android Tablet",cros:"Chrome OS",fennec:"Android Tablet",ipad:"IPad",iphone:"IPhone",jsdom:"JsDOM",linux:"Linux",mac:"Macintosh",tablet:"Android Tablet",win:"Windows","windows phone":"Windows Phone",xbox:"Microsoft Xbox"},i="2.0.0",o={toFixed:function(e,r){var i=new RegExp("^-?\\d+(?:.\\d{0,".concat(r||-1,"})?"));return e.toString().match(i)[0]}};return function(t){var n=this;this.userAgent=t||window.navigator.userAgent,this.__VERSION__=i,this.parseUserAgent=function(i){var t={},s=i||n.userAgent,a=s.toLowerCase().replace(/\s\s+/g," "),d=/(edge)\/([\w.]+)/.exec(a)||/(opr)[/]([\w.]+)/.exec(a)||/(jsdom)[/]([\w.]+)/.exec(a)||/(samsungbrowser)[/]([\w.]+)/.exec(a)||/(chrome)[/]([\w.]+)/.exec(a)||/(crios)[/]([\w.]+)/.exec(a)||/(opios)[/]([\w.]+)/.exec(a)||/(version)(applewebkit)[/]([\w.]+).*(safari)[/]([\w.]+)/.exec(a)||/(webkit)[/]([\w.]+).*(version)[/]([\w.]+).*(safari)[/]([\w.]+)/.exec(a)||/(applewebkit)[/]([\w.]+).*(safari)[/]([\w.]+)/.exec(a)||/(webkit)[/]([\w.]+)/.exec(a)||/(opera)(?:.*version|)[/]([\w.]+)/.exec(a)||/(msie) ([\w.]+)/.exec(a)||/(fennec)[/]([\w.]+)/.exec(a)||a.indexOf("trident")>=0&&/(rv)(?::| )([\w.]+)/.exec(a)||a.indexOf("compatible")<0&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(a)||[],c=/(ipad)/.exec(a)||/(ipod)/.exec(a)||/(iphone)/.exec(a)||/(jsdom)/.exec(a)||/(windows phone)/.exec(a)||/(xbox)/.exec(a)||/(win)/.exec(a)||/(tablet)/.exec(a)||/(android)/.test(a)&&!1===/(mobile)/.test(a)&&["androidTablet"]||/(android)/.exec(a)||/(mac)/.exec(a)||/(linux)/.exec(a)||/(cros)/.exec(a)||[],l={name:d[5]||d[3]||d[1]||null,platform:c[0]||null,userAgent:s,version:d[4]||d[2]||null};return l.name&&(t[l.name]=!0,l.name=e[l.name]||"Unknown"),l.platform&&(t[l.platform]=!0,l.platform=r[l.platform]),l.version&&(l.shortVersion=o.toFixed(parseFloat(l.version),2)),l.isAndroid=!!(t.tablet||t.android||t.androidTablet),l.isTablet=!!(t.ipad||t.tablet||t.androidTablet),l.isMobile=!!(t.android||t.androidTablet||t.tablet||t.ipad||t.ipod||t.iphone||t["windows phone"]),l.isDesktop=!!(t.cros||t.mac||t.linux||t.win),l.isWebkit=!!(t.chrome||t.crios||t.opr||t.safari),l.isIE=!(!t.msie&&!t.rv),l},this.getBrowserInfo=function(){var e=n.parseUserAgent();return delete e.isAndroid,delete e.isMobile,delete e.isTablet,delete e.isWebkit,delete e.isDesktop,delete e.isIE,e},this.getBrowserName=function(){return n.parseUserAgent().name},this.getBrowserVersion=function(){return n.parseUserAgent().version},this.getBrowserShortVersion=function(){return n.parseUserAgent().shortVersion},this.getPlatformName=function(){return n.parseUserAgent().platform},this.isAndroid=function(){return n.parseUserAgent().isAndroid},this.isTablet=function(){return n.parseUserAgent().isTablet},this.isMobile=function(){return n.parseUserAgent().isMobile},this.isWebkit=function(){return n.parseUserAgent().isWebkit},this.isDesktop=function(){return n.parseUserAgent().isDesktop},this.isIE=function(){return n.parseUserAgent().isIE},Object.freeze(this)}}));